#!/usr/bin/env python
# encoding: utf-8
"""
test_xml_storage.py

Created by Sebastian Höhn on 2008-01-29.
Copyright (c) 2008 __MyCompanyName__. All rights reserved.
"""

import os
from XMLStorage import XMLStorage

class TestXMLStorage(object):
    
    def test_creation(self):
        """Test creation of XMLStorage"""
        store = XMLStorage()
        assert(os.path.exists("data/"))
    
    def test_store(self):
        """Test storing of resources"""
        store = XMLStorage()
        store.clearCollection("db.test")
        store.store("db.test", "<test>me</test>")
    
    def test_retrieve(self):
        """Test retrieval of xml resources"""
        store = XMLStorage()
        store.clearCollection("db.test")
        store.store("db.test", "<a>This is the test entry</a>")
        res = store.retrieve("db.test", "//a")
        
        assert res[0].localName == "a"
    
    def test_remove(self):
        """Test removal of resources via XPath"""
        store = XMLStorage()
        store.clearCollection("db.test_remove")
        store.store("db.test_remove", "<a>This is a</a>")
        store.store("db.test_remove", "<b>This is b</b>")
        store.removeResource("db.test_remove", "//a")
        
    
if __name__ == "__main__":
    t = TestXMLStorage()
    t.test_retrieve()