# Create a unique variable name for the prolog code generation.
def unique_variables():
    """Generate unique variable names for the prolog code."""
    c = range(ord('A'), ord('Z') + 1)
    s = ""
    n = 0
    last = 0
    while True:
        n = last
        while n > 25:
            s = chr(c[n % 26]) + s
            n = n / 26
        s = chr(c[n]) + s
        yield s
        s=""
        last = last + 1

try:
    unique_variable_generator
except:
    unique_variable_generator = unique_variables()

#
#     Python has generators, so no need for this crap
#

# class VariableGenerator(Singleton):
#     # @AttributeType int
#     # The value of the last string that has been generated.
#     ___lastString = -1
#     
#     def __init__(self):
#         """Create a new variable generator"""
#         pass
#         
#     # @ReturnType string
#     # get the next variable name.
#     def getNext(self):
#         self.___lastString = self.___lastString + 1
#         return self.__generate()
# 
#     # Reset the generator. After the reset variable names are no longer unique!
#     def reset(self):
#         self.___lastString = -1
# 
#     # Helper for generating the unique string.
#     def __generate(self):
#         c = range(ord('A'), ord('Z') + 1)
#         s = ""
#         n = self.___lastString
#         
#         while n > 25:
#             s = chr(c[n % 26]) + s
#             n = n / 26
#         
#         s = chr(c[n]) + s
#         return s
