import os,sys, marshal
import xml.sax

# Read information from the xml files. Information files must follow the meta-model given in the XMI file.

# 
#  The information is parsed into a dictionary of lists
#  the key value is the class name and the list entries
#  are the instances of this information. One instance is
#  represented as a dictionary containing the attributes.
#
# TODO make the methods static.
class InformationParser(object):
    
    # @AttributeType string
    # The default storage for information. 
    # TODO: parameterize in the config file for additional flexibility.
    ___STORAGE = 'data/db.information'

    # Clear the storage used for information files. This is needed, because several information files can be read for scalability.
    @staticmethod
    def clearStorage():
        """Clear the storage for information"""
        os.remove(self.___STORAGE)

    # @ReturnType void
    # @ParamType aFilename string
    # Parse the file to the given repository.
    @staticmethod
    def parse(aFilename = "sample/sample_info.xml", config=None):
        """Parse the given info file and write it to the storage.
        
        The structure of this file must match the model in the storage!
        """
        if config == None:
            config = ConfigParser.ConfigParser()
            config.readfp(open('rubacon/defaults.cfg'))
            logging.debug("Created config parser in informationParser.")
            
        InformationParser.___STORAGE = config.get('information', 'storage')
        model_storage = config.get('model', 'storage')
        inf = open(model_storage)
        a = marshal.load(inf)
        inf.close()
        # Just read the classnames into a list:
        classList = []
        attrList = {}
        for c in a['classDefs']:
            classList.append(c['name'])
            attrList[c['name']] = c['attrs']
        
        # Start parsing the file:
        ih = information_handler(classList)
        xml.sax.parse(aFilename, ih)
        ouf = open(InformationParser.___STORAGE, 'wb')
        marshal.dump(ih.resultHash, ouf)
        ouf.close()
        return ih.resultHash

class information_handler(xml.sax.ContentHandler):
    """Parse the information file to a list of objects"""
    def __init__(self, classList):
        """Use the classnames and their attributes to
        validate the structure."""
        self.classList = classList
        self.resultHash = {}
    
    def startElement(self, name, attrs):
        """start the parsing of an element"""
        
        # This is the document element and it
        # is not defined in the model of the application!
        if name == 'information':
            return 
            
        if not name in self.classList:
            print >> sys.stderr, "Structure of information file invalid:"
            print >> sys.stderr, "'%s' is not defined in the model." % name
            return
        
        # add the attrs to the info hash:
        if not name in self.resultHash:
            self.resultHash[name] = []
        entryList = self.resultHash[name]
        entryHash = {}
        for key,value in attrs.items():
            entryHash[key] = value
        entryList.append(entryHash)
    
